/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables.interfaces


import javax.annotation.Generated
import javax.validation.constraints.NotNull
import javax.validation.constraints.Size
import java.io.Serializable
import java.sql.Date
import java.sql.Timestamp


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
interface IUsers : Serializable {

    /**
     * Getter for `public.users.id`.
     */
    /**
     * Setter for `public.users.id`.
     */
    var id: Long?

    /**
     * Getter for `public.users.name`.
     */
    /**
     * Setter for `public.users.name`.
     */
    @get:NotNull
    @get:Size(max = 200)
    var name: String

    /**
     * Getter for `public.users.password`.
     */
    /**
     * Setter for `public.users.password`.
     */
    @get:NotNull
    @get:Size(max = 512)
    var password: String

    /**
     * Getter for `public.users.email`.
     */
    /**
     * Setter for `public.users.email`.
     */
    @get:Size(max = 254)
    var email: String

    /**
     * Getter for `public.users.age`.
     */
    /**
     * Setter for `public.users.age`.
     */
    var age: Int?

    /**
     * Getter for `public.users.city`.
     */
    /**
     * Setter for `public.users.city`.
     */
    @get:Size(max = 122)
    var city: String

    /**
     * Getter for `public.users.location`.
     */
    /**
     * Setter for `public.users.location`.
     */
    var location: Any

    /**
     * Getter for `public.users.birthday`.
     */
    /**
     * Setter for `public.users.birthday`.
     */
    var birthday: Date

    /**
     * Getter for `public.users.created_stamp`.
     */
    /**
     * Setter for `public.users.created_stamp`.
     */
    var createdStamp: Timestamp

    /**
     * Getter for `public.users.active`.
     */
    /**
     * Setter for `public.users.active`.
     */
    var active: Boolean?

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * Load data from another generated Record/POJO implementing the common interface IUsers
     */
    fun from(from: IUsers)

    /**
     * Copy data into another generated Record/POJO implementing the common interface IUsers
     */
    fun <E : IUsers> into(into: E): E
}
